--- old/usr/src/cmd/fs.d/nfs/mountd/mountd.c	Mon Feb 10 08:41:43 2020
+++ new/usr/src/cmd/fs.d/nfs/mountd/mountd.c	Mon Feb 10 08:41:43 2020
@@ -21,7 +21,6 @@
 
 /*
  * Copyright (c) 1989, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright 2012 Joyent, Inc. All rights reserved.
  * Copyright (c) 2012, 2016 by Delphix. All rights reserved.
  * Copyright 2016 Nexenta Systems, Inc.  All rights reserved.
  */
@@ -486,13 +485,6 @@
 		    "%s: must be run with sufficient privileges\n",
 		    argv[0]);
 		exit(1);
-	}
-
-	/* Mountd cannot run in a non-global zone. */
-	if (getzoneid() != GLOBAL_ZONEID) {
-		(void) fprintf(stderr, "%s: can only run in the global zone\n",
-		    argv[0]);
-		exit(1);
 	}
 
 	if (getrlimit(RLIMIT_NOFILE, &rl) != 0) {
--- old/usr/src/cmd/fs.d/nfs/nfsd/nfsd.c	Mon Feb 10 08:41:43 2020
+++ new/usr/src/cmd/fs.d/nfs/nfsd/nfsd.c	Mon Feb 10 08:41:43 2020
@@ -20,7 +20,6 @@
  */
 /*
  * Copyright (c) 1989, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright (c) 2012, Joyent, Inc. All rights reserved.
  */
 
 /*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T		*/
@@ -176,13 +175,6 @@
 		    " sufficient privileges\n", av[0]);
 		exit(1);
 	}
-
-	/* Nfsd cannot run in a non-global zone. */
-	if (getzoneid() != GLOBAL_ZONEID) {
-		(void) fprintf(stderr, "%s: can only run in the global zone\n",
-		    av[0]);
-		exit(1);
-	}
 
 	(void) enable_extended_FILE_stdio(-1, -1);
 
--- old/usr/src/cmd/fs.d/nfs/svc/nfs-server	Mon Feb 10 08:41:43 2020
+++ new/usr/src/cmd/fs.d/nfs/svc/nfs-server	Mon Feb 10 08:41:43 2020
@@ -53,6 +53,7 @@
 
         #
 	# Nothing to do if:
+	# - service's policy is 'use_global'
         # - ipfilter isn't online
 	# - global policy is 'custom'
         #
--- old/usr/src/lib/brand/joyent-minimal/zone/platform.xml	Mon Feb 10 08:41:44 2020
+++ new/usr/src/lib/brand/joyent-minimal/zone/platform.xml	Mon Feb 10 08:41:44 2020
@@ -51,6 +51,7 @@
 	    opt="nodevices" type="lofs" />
 	<global_mount special="%R/ccs" directory="/usr/ccs"
 	    opt="nodevices" type="lofs" />
+	<mount special="sharefs" directory="/etc/dfs/sharetab" type="sharefs" />
 
 	<!-- Local filesystems to mount when booting the zone -->
 	<mount special="/proc" directory="/proc" type="proc" />
--- old/usr/src/lib/brand/joyent/zone/manifests	Mon Feb 10 08:41:44 2020
+++ new/usr/src/lib/brand/joyent/zone/manifests	Mon Feb 10 08:41:44 2020
@@ -116,6 +116,7 @@
 network/nfs/nlockmgr.xml				disabled
 network/nfs/rquota.xml					disabled
 network/nfs/status.xml					disabled
+network/nfs/server.xml					disabled
 network/nis/client.xml					disabled
 network/rexec.xml					disabled
 network/routing/legacy-routing.xml			enabled
--- old/usr/src/lib/brand/joyent/zone/platform.xml	Mon Feb 10 08:41:44 2020
+++ new/usr/src/lib/brand/joyent/zone/platform.xml	Mon Feb 10 08:41:44 2020
@@ -59,6 +59,7 @@
 	<mount special="objfs" directory="/system/object" type="objfs" />
 	<mount special="lxproc" directory="/system/lxproc" type="lxproc" />
 	<mount special="swap" directory="/etc/svc/volatile" type="tmpfs" />
+	<mount special="sharefs" directory="/etc/dfs/sharetab" type="sharefs" />
 
 	<!-- Devices to create under /dev -->
 	<device match="arp" />
--- old/usr/src/uts/common/fs/nfs/nfs_auth.c	Mon Feb 10 08:41:44 2020
+++ new/usr/src/uts/common/fs/nfs/nfs_auth.c	Mon Feb 10 08:41:44 2020
@@ -21,7 +21,6 @@
 
 /*
  * Copyright (c) 1995, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright (c) 2015 Joyent, Inc.  All rights reserved.
  * Copyright (c) 2015 by Delphix. All rights reserved.
  * Copyright (c) 2015 Joyent, Inc.  All rights reserved.
  * Copyright 2018 Nexenta Systems, Inc. All rights reserved.
--- old/usr/src/uts/common/fs/nfs/nfs_sys.c	Mon Feb 10 08:41:44 2020
+++ new/usr/src/uts/common/fs/nfs/nfs_sys.c	Mon Feb 10 08:41:44 2020
@@ -22,8 +22,6 @@
 /*
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
- * Copyright 2017 Joyent, Inc.
- *
  */
 
 /*
@@ -32,6 +30,7 @@
  */
 
 /*
+ * Copyright 2017 Joyent, Inc.
  * Copyright 2018 Nexenta Systems, Inc.
  */
 
--- old/usr/src/uts/common/klm/nlm_impl.h	Mon Feb 10 08:41:44 2020
+++ new/usr/src/uts/common/klm/nlm_impl.h	Mon Feb 10 08:41:44 2020
@@ -460,6 +460,7 @@
 	int				cn_idle_tmo;		/* (z) */
 	int				grace_period;		/* (z) */
 	int				retrans_tmo;		/* (z) */
+	boolean_t			nlm_v4_only;		/* (z) */
 	zoneid_t			nlm_zoneid;		/* (c) */
 	kmutex_t			clean_lock;		/* (c) */
 	TAILQ_ENTRY(nlm_globals)	nlm_link;		/* (g) */
--- old/usr/src/uts/common/sys/zone.h	Mon Feb 10 08:41:44 2020
+++ new/usr/src/uts/common/sys/zone.h	Mon Feb 10 08:41:44 2020
@@ -53,6 +53,7 @@
 #include <sys/nvpair.h>
 #include <sys/list.h>
 #include <sys/loadavg.h>
+#include <sys/vnode.h>
 #endif	/* _KERNEL */
 
 #ifdef	__cplusplus
@@ -949,7 +950,7 @@
  * NOTE:  Using the VN_ prefix, even though it's defined here in zone.h.
  * NOTE2: See above warning about ZONE_ROOTVP().
  */
-#define	VN_IS_CURZONEROOT(vp)   (VN_CMP(vp, ZONE_ROOTVP()))
+#define	VN_IS_CURZONEROOT(vp)	(VN_CMP(vp, ZONE_ROOTVP()))
 
 /*
  * Zone-safe version of thread_create() to be used when the caller wants to
